
_main:
;123.c,26 :: 		void main()
;123.c,28 :: 		CMCON |= 7;
	MOVLW      7
	IORWF      CMCON+0, 1
;123.c,29 :: 		TRISB = 0;                           // Set PORTB direction to be output;
	CLRF       TRISB+0
;123.c,30 :: 		PORTB = 0;                        // Turn OFF LEDs on PORTA;
	CLRF       PORTB+0
;123.c,31 :: 		trisb3_bit = 0;
	BCF        TRISB3_bit+0, 3
;123.c,32 :: 		TRISA6_bit = 1;                      // Set PORT RB1 input for button;
	BSF        TRISA6_bit+0, 6
;123.c,33 :: 		oldstate = 0;                        // Define value of oldstate;
	CLRF       _oldstate+0
;123.c,34 :: 		current_duty = 0;          // Initial value of variable current_duty;
	CLRF       _current_duty+0
;123.c,35 :: 		last_duty = 0;             // Reset variable last_duty;
	CLRF       _last_duty+0
;123.c,36 :: 		pwm1_init(5000);           // PWM module initialization (5KHz);
	BCF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      249
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;123.c,37 :: 		pwm1_start();              // Start PWM1 module;
	CALL       _PWM1_Start+0
;123.c,38 :: 		pwm1_set_duty(last_duty);
	MOVF       _last_duty+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;123.c,42 :: 		do {
L_main0:
;123.c,50 :: 		if (Button(&PORTA,0,1,1)) oldstate = 1;
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main2
	MOVLW      1
	MOVWF      _oldstate+0
L_main2:
;123.c,51 :: 		Delay_ms(100);                                              //delay for prevent crash
	MOVLW      163
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main3:
	DECFSZ     R13+0, 1
	GOTO       L_main3
	DECFSZ     R12+0, 1
	GOTO       L_main3
;123.c,52 :: 		if (oldstate &&Button(&PORTA,0,1,0)) {
	MOVF       _oldstate+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main6
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main6
L__main25:
;123.c,53 :: 		led = ~led;       //invert state
	MOVLW      1
	XORWF      RB0_bit+0, 1
;123.c,54 :: 		oldstate = 0;
	CLRF       _oldstate+0
;123.c,55 :: 		}
L_main6:
;123.c,58 :: 		if (Button(&PORTA,1,1,1)) oldstate = 1;
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main7
	MOVLW      1
	MOVWF      _oldstate+0
L_main7:
;123.c,59 :: 		Delay_ms(100);                                              //delay for prevent crash
	MOVLW      163
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main8:
	DECFSZ     R13+0, 1
	GOTO       L_main8
	DECFSZ     R12+0, 1
	GOTO       L_main8
;123.c,60 :: 		if (oldstate &&Button(&PORTA,1,1,0)) {
	MOVF       _oldstate+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main11
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main11
L__main24:
;123.c,61 :: 		led1 = ~led1;       //invert state
	MOVLW      2
	XORWF      RB1_bit+0, 1
;123.c,62 :: 		oldstate = 0;
	CLRF       _oldstate+0
;123.c,63 :: 		}
L_main11:
;123.c,65 :: 		if (Button(&PORTA,2,1,1)) oldstate = 1;
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      2
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main12
	MOVLW      1
	MOVWF      _oldstate+0
L_main12:
;123.c,66 :: 		Delay_ms(100);                                              //delay for prevent crash
	MOVLW      163
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main13:
	DECFSZ     R13+0, 1
	GOTO       L_main13
	DECFSZ     R12+0, 1
	GOTO       L_main13
;123.c,67 :: 		if (oldstate &&Button(&PORTA,2,1,0)) {
	MOVF       _oldstate+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main16
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      2
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main16
L__main23:
;123.c,68 :: 		led2 = ~led2;       //invert state
	MOVLW      4
	XORWF      RB2_bit+0, 1
;123.c,69 :: 		oldstate = 0;
	CLRF       _oldstate+0
;123.c,70 :: 		}
L_main16:
;123.c,71 :: 		if (Button(&PORTA,3,1,1)) oldstate = 1;
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      3
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main17
	MOVLW      1
	MOVWF      _oldstate+0
L_main17:
;123.c,72 :: 		Delay_ms(100);                                              //delay for prevent crash
	MOVLW      163
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main18:
	DECFSZ     R13+0, 1
	GOTO       L_main18
	DECFSZ     R12+0, 1
	GOTO       L_main18
;123.c,73 :: 		if (oldstate &&Button(&PORTA,3,1,0)) {
	MOVF       _oldstate+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      3
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
L__main22:
;123.c,74 :: 		led3 = ~led3;       //invert state
	MOVLW      16
	XORWF      RB4_bit+0, 1
;123.c,75 :: 		oldstate = 0;
	CLRF       _oldstate+0
;123.c,76 :: 		}
L_main21:
;123.c,97 :: 		} while(1);                                                 //Infinite loop.
	GOTO       L_main0
;123.c,105 :: 		}
	GOTO       $+0
; end of _main
